diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/int64x64-test-suite.cc ns-3.42/src/core/test/int64x64-test-suite.cc
--- ns-3.41/src/core/test/int64x64-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/int64x64-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -575,6 +575,35 @@
 
     // Check special values
     Check(51, int64x64_t(0, 0x159fa87f8aeaad21ULL) * 10, int64x64_t(0, 0xd83c94fb6d2ac34aULL));
+    {
+        auto x = int64x64_t(std::numeric_limits<int64_t>::min(), 0);
+        Check(52, x * 1, x);
+        Check(53, 1 * x, x);
+    }
+    {
+        int64x64_t x(1 << 30, (static_cast<uint64_t>(1) << 63) + 1);
+        auto ret = x * x;
+        int64x64_t expected(1152921505680588800, 4611686020574871553);
+        // The real difference between ret and expected is 2^-128.
+        int64x64_t tolerance = 0;
+        if (int64x64_t::implementation == int64x64_t::ld_impl)
+        {
+            tolerance = tol1;
+        }
+        Check(54, ret, expected, tolerance);
+    }
+
+    // The following triggers an assert in int64x64-128.cc:Umul():117
+    /*
+    {
+        auto x = int64x64_t(1LL << 31);   // 2^31
+        auto y = 2 * x;                   // 2^32
+        Check(55, x, x);
+        Check(56, y, y);
+        auto z [[maybe_unused]] = x * y;  // 2^63 < 0, triggers assert
+        Check(57, z, z);
+    }
+    */
 }
 
 /**
@@ -1557,20 +1586,20 @@
 {
   public:
     Int64x64TestSuite()
-        : TestSuite("int64x64", UNIT)
+        : TestSuite("int64x64", Type::UNIT)
     {
-        AddTestCase(new Int64x64ImplTestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64HiLoTestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64IntRoundTestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64ArithmeticTestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64CompareTestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64InputTestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64InputOutputTestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64Bug455TestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64Bug863TestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64Bug1786TestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64InvertTestCase(), TestCase::QUICK);
-        AddTestCase(new Int64x64DoubleTestCase(), TestCase::QUICK);
+        AddTestCase(new Int64x64ImplTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64HiLoTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64IntRoundTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64ArithmeticTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64CompareTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64InputTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64InputOutputTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64Bug455TestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64Bug863TestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64Bug1786TestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64InvertTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new Int64x64DoubleTestCase(), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/length-test-suite.cc ns-3.42/src/core/test/length-test-suite.cc
--- ns-3.41/src/core/test/length-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/length-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -1605,8 +1605,8 @@
 LengthTestSuite::LengthTestSuite()
     : TestSuite("length")
 {
-    AddTestCase(new LengthTestCase(), TestCase::QUICK);
-    AddTestCase(new LengthValueTestCase(), TestCase::QUICK);
+    AddTestCase(new LengthTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new LengthValueTestCase(), TestCase::Duration::QUICK);
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/many-uniform-random-variables-one-get-value-call-test-suite.cc ns-3.42/src/core/test/many-uniform-random-variables-one-get-value-call-test-suite.cc
--- ns-3.41/src/core/test/many-uniform-random-variables-one-get-value-call-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/many-uniform-random-variables-one-get-value-call-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -28,7 +28,7 @@
  * \file
  * \ingroup core-tests
  * \ingroup randomvariable
- * \ingroup randomvariable-tests
+ * \ingroup rng-tests
  * Test for many uniform random variable streams.
  */
 
@@ -39,15 +39,13 @@
 {
 
 /**
- * \ingroup randomvariable-tests
+ * \ingroup rng-tests
  * Test case for many uniform distribution random variable stream generators
  */
 class ManyUniformRandomVariablesOneGetValueCallTestCase : public TestCase
 {
   public:
-    /** Constructor. */
     ManyUniformRandomVariablesOneGetValueCallTestCase();
-    /** Destructor. */
     ~ManyUniformRandomVariablesOneGetValueCallTestCase() override;
 
   private:
@@ -89,25 +87,24 @@
 }
 
 /**
- * \ingroup randomvariable-tests
+ * \ingroup rng-tests
  * Test suite for many uniform distribution random variable stream generators
  */
 class ManyUniformRandomVariablesOneGetValueCallTestSuite : public TestSuite
 {
   public:
-    /** Constructor. */
     ManyUniformRandomVariablesOneGetValueCallTestSuite();
 };
 
 ManyUniformRandomVariablesOneGetValueCallTestSuite::
     ManyUniformRandomVariablesOneGetValueCallTestSuite()
-    : TestSuite("many-uniform-random-variables-one-get-value-call", PERFORMANCE)
+    : TestSuite("many-uniform-random-variables-one-get-value-call", Type::PERFORMANCE)
 {
     AddTestCase(new ManyUniformRandomVariablesOneGetValueCallTestCase);
 }
 
 /**
- * \ingroup randomvariable-tests
+ * \ingroup rng-tests
  * ManuUniformRandomVariablesOneGetValueCallTestSuite instance variable.
  */
 static ManyUniformRandomVariablesOneGetValueCallTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/matrix-array-test-suite.cc ns-3.42/src/core/test/matrix-array-test-suite.cc
--- ns-3.41/src/core/test/matrix-array-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/matrix-array-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -22,9 +22,13 @@
 #include "ns3/test.h"
 
 /**
- * \file
+ * \defgroup matrixArray-tests MatrixArray tests
  * \ingroup core-tests
- * \ingroup matrixArray
+ * \ingroup Matrices
+ */
+
+/**
+ * \file
  * \ingroup matrixArray-tests
  * MatrixArray test suite
  */
@@ -37,6 +41,27 @@
 NS_LOG_COMPONENT_DEFINE("MatrixArrayTest");
 
 /**
+ * \brief Function casts an input valArray "in" (type IN) to an output valArray "out" (type T)
+ * \param in Input valarray to be casted
+ * \param out Output valarray to receive casted values
+ */
+template <typename IN, typename T>
+void
+CastStdValarray(const std::valarray<IN>& in, std::valarray<T>& out)
+{
+    // Ensure output valarray is the right size
+    if (out.size() != in.size())
+    {
+        out.resize(in.size());
+    }
+
+    // Perform the cast operation
+    std::transform(std::begin(in), std::end(in), std::begin(out), [](IN i) {
+        return static_cast<T>(i);
+    });
+}
+
+/**
  * \ingroup matrixArray-tests
  *  MatrixArray test case for testing constructors, operators and other functions
  */
@@ -439,6 +464,154 @@
     MatrixArray<T> m27 = MatrixArray<T>(std::move(jCasted));
     NS_LOG_INFO("m27.GetSize ()" << m27.GetSize());
     NS_TEST_ASSERT_MSG_EQ(jCastedSize, m27.GetSize(), "The number of elements are not equal.");
+
+    // test determinant
+    {
+        std::vector<std::pair<std::valarray<int>, T>> detTestCases{
+            // right-wraparound
+            {{1, 0, 7, 4, 2, 0, 6, 5, 3}, 62},
+            // left-wraparound
+            {{1, 4, 6, 0, 2, 5, 7, 0, 3}, 62},
+            // identity rank 3
+            {{1, 0, 0, 0, 1, 0, 0, 0, 1}, 1},
+            // identity rank 4
+            {{1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1}, 1},
+            // permutation matrix rank 4
+            {{0, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0}, -1},
+            // positive det matrix rank 2
+            {{36, -5, -5, 43}, 1523},
+            // single value matrix rank 1
+            {{1}, 1},
+        };
+        for (const auto& [detVal, detRef] : detTestCases)
+        {
+            std::valarray<T> detCast(detVal.size());
+            CastStdValarray(detVal, detCast);
+            auto side = sqrt(detVal.size());
+            MatrixArray<T> detMat = MatrixArray<T>(side, side, std::move(detCast));
+            NS_TEST_ASSERT_MSG_EQ(detMat.Determinant()(0),
+                                  static_cast<T>(detRef),
+                                  "The determinants are not equal.");
+        }
+    }
+    // clang-format off
+    std::valarray<int> multiPageMatrixValues{
+            // page 0: identity matrix
+            1, 0, 0,
+            0, 1, 0,
+            0, 0, 1,
+            // page 1: permutation matrix
+            0, 0, 1,
+            0, 1, 0,
+            1, 0, 0,
+            // page 2: random matrix
+            1, 4, 6,
+            0, 2, 5,
+            7, 0, 3,
+            // page 3: upper triangular
+            5, -9, 2,
+            0, -4, -10,
+            0, 0, -3,
+            // page 4: lower triangular
+            -7, 0, 0,
+            -1, -9, 0,
+            -5, 6, -5,
+            // page 5: zero diagonal
+            0, 1, 2,
+            1, 0, 1,
+            2, 1, 0,
+            // page 6: zero bidiagonal
+            0, 1, 0,
+            1, 0, 1,
+            0, 1, 0
+    };
+    // clang-format on
+    std::valarray<T> castMultiPageMatrixValues(multiPageMatrixValues.size());
+    CastStdValarray(multiPageMatrixValues, castMultiPageMatrixValues);
+    MatrixArray<T> multiPageMatrix = MatrixArray<T>(3,
+                                                    3,
+                                                    multiPageMatrixValues.size() / 9,
+                                                    std::move(castMultiPageMatrixValues));
+    // test the determinant in a multi-page MatrixArray
+    std::vector<int> determinants = {1, -1, 62, 60, -315, 4, 0};
+    auto det = multiPageMatrix.Determinant();
+    for (size_t page = 0; page < multiPageMatrix.GetNumPages(); page++)
+    {
+        NS_TEST_ASSERT_MSG_EQ(det(page),
+                              static_cast<T>(determinants[page]),
+                              "The determinants from the page " << std::to_string(page)
+                                                                << " are not equal.");
+    }
+
+    // test Frobenius norm in a multi-page MatrixArray
+    std::vector<double> fnorms = {sqrt(3), sqrt(3), 11.8322, 15.3297, 14.7309, 3.4641, 2};
+    auto frob = multiPageMatrix.FrobeniusNorm();
+    for (size_t page = 0; page < multiPageMatrix.GetNumPages(); page++)
+    {
+        NS_TEST_ASSERT_MSG_EQ_TOL(std::abs(frob(page)),
+                                  std::abs(static_cast<T>(fnorms[page])),
+                                  0.0001,
+                                  "The Frobenius norm from the page " << std::to_string(page)
+                                                                      << " are not equal.");
+    }
+
+    // test page copying
+    for (size_t noOfCopies = 1; noOfCopies < 4; noOfCopies++)
+    {
+        auto copies = m27.MakeNCopies(noOfCopies);
+        NS_TEST_ASSERT_MSG_EQ(copies.GetNumPages(),
+                              noOfCopies,
+                              "Creating " << std::to_string(noOfCopies) << " copies failed.");
+        NS_TEST_ASSERT_MSG_EQ(copies.GetNumRows(),
+                              m27.GetNumRows(),
+                              "The copy doesn't have the same number of rows as the original.");
+        NS_TEST_ASSERT_MSG_EQ(copies.GetNumCols(),
+                              m27.GetNumCols(),
+                              "The copy doesn't have the same number of columns as the original.");
+        for (size_t page = 0; page < copies.GetNumPages(); page++)
+        {
+            T diff{};
+            for (size_t row = 0; row < copies.GetNumRows(); row++)
+            {
+                for (size_t col = 0; col < copies.GetNumCols(); col++)
+                {
+                    diff += m27(row, col, 0) - copies(row, col, page);
+                }
+            }
+            NS_TEST_ASSERT_MSG_EQ(diff, T{}, "Mismatch in copied values.");
+        }
+    }
+
+    // test page 1 and 0 extraction
+    std::vector<MatrixArray<T>> pages{multiPageMatrix.ExtractPage(1),
+                                      multiPageMatrix.ExtractPage(0)};
+
+    // test page 1 and 0 joining
+    auto jointPagesMatrix = MatrixArray<T>::JoinPages(pages);
+    NS_TEST_ASSERT_MSG_EQ(jointPagesMatrix.GetNumPages(), 2, "Mismatch in number of join pages.");
+    for (size_t page = 0; page < jointPagesMatrix.GetNumPages(); page++)
+    {
+        T diff{};
+        for (size_t row = 0; row < jointPagesMatrix.GetNumRows(); row++)
+        {
+            for (size_t col = 0; col < jointPagesMatrix.GetNumCols(); col++)
+            {
+                diff += multiPageMatrix(row, col, 1 - page) - jointPagesMatrix(row, col, page);
+            }
+        }
+        NS_TEST_ASSERT_MSG_EQ(diff, T{}, "Mismatching pages.");
+    }
+
+    // test identity matrix
+    auto identityRank3Reference = multiPageMatrix.ExtractPage(0);
+    auto identityRank3 = MatrixArray<T>::IdentityMatrix(3);
+    NS_TEST_ASSERT_MSG_EQ(identityRank3, identityRank3Reference, "Mismatch in identity matrices.");
+
+    identityRank3 = MatrixArray<T>::IdentityMatrix(3, 10).ExtractPage(9);
+    NS_TEST_ASSERT_MSG_EQ(identityRank3, identityRank3Reference, "Mismatch in identity matrices.");
+
+    identityRank3 = MatrixArray<T>::IdentityMatrix(identityRank3Reference);
+    NS_TEST_ASSERT_MSG_EQ(identityRank3, identityRank3Reference, "Mismatch in identity matrices.");
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/object-test-suite.cc ns-3.42/src/core/test/object-test-suite.cc
--- ns-3.41/src/core/test/object-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/object-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -466,6 +466,74 @@
 
 /**
  * \ingroup object-tests
+ * Test we can aggregate Objects.
+ */
+class UnidirectionalAggregateObjectTestCase : public TestCase
+{
+  public:
+    /** Constructor. */
+    UnidirectionalAggregateObjectTestCase();
+    /** Destructor. */
+    ~UnidirectionalAggregateObjectTestCase() override;
+
+  private:
+    void DoRun() override;
+};
+
+UnidirectionalAggregateObjectTestCase::UnidirectionalAggregateObjectTestCase()
+    : TestCase("Check Object unidirectional aggregation functionality")
+{
+}
+
+UnidirectionalAggregateObjectTestCase::~UnidirectionalAggregateObjectTestCase()
+{
+}
+
+void
+UnidirectionalAggregateObjectTestCase::DoRun()
+{
+    Ptr<BaseA> baseAOne = CreateObject<BaseA>();
+    NS_TEST_ASSERT_MSG_NE(baseAOne, nullptr, "Unable to CreateObject<BaseA>");
+    Ptr<BaseA> baseATwo = CreateObject<BaseA>();
+    NS_TEST_ASSERT_MSG_NE(baseATwo, nullptr, "Unable to CreateObject<BaseA>");
+
+    Ptr<BaseB> baseB = CreateObject<BaseB>();
+    NS_TEST_ASSERT_MSG_NE(baseB, nullptr, "Unable to CreateObject<BaseB>");
+
+    //
+    // Make an unidirectional aggregation of a BaseA object and a BaseB object.
+    //
+    baseAOne->UnidirectionalAggregateObject(baseB);
+    baseATwo->UnidirectionalAggregateObject(baseB);
+
+    //
+    // We should be able to ask the aggregation (through baseA) for the BaseB part
+    // on either BaseA objects
+    //
+    NS_TEST_ASSERT_MSG_NE(baseAOne->GetObject<BaseB>(),
+                          nullptr,
+                          "Cannot GetObject (through baseAOne) for BaseB Object");
+
+    NS_TEST_ASSERT_MSG_NE(baseATwo->GetObject<BaseB>(),
+                          nullptr,
+                          "Cannot GetObject (through baseATwo) for BaseB Object");
+
+    NS_TEST_ASSERT_MSG_EQ(
+        baseAOne->GetObject<BaseB>(),
+        baseATwo->GetObject<BaseB>(),
+        "GetObject (through baseAOne and baseATwo) for BaseB Object are not equal");
+
+    //
+    // We should not be able to ask the aggregation (through baseB) for the BaseA part
+    // of the aggregation.
+    //
+    NS_TEST_ASSERT_MSG_NE(!baseB->GetObject<BaseA>(),
+                          0,
+                          "Can GetObject (through baseB) for BaseA Object");
+}
+
+/**
+ * \ingroup object-tests
  * Test an Object factory can create Objects
  */
 class ObjectFactoryTestCase : public TestCase
@@ -565,6 +633,7 @@
 {
     AddTestCase(new CreateObjectTestCase);
     AddTestCase(new AggregateObjectTestCase);
+    AddTestCase(new UnidirectionalAggregateObjectTestCase);
     AddTestCase(new ObjectFactoryTestCase);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/one-uniform-random-variable-many-get-value-calls-test-suite.cc ns-3.42/src/core/test/one-uniform-random-variable-many-get-value-calls-test-suite.cc
--- ns-3.41/src/core/test/one-uniform-random-variable-many-get-value-calls-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/one-uniform-random-variable-many-get-value-calls-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -28,7 +28,7 @@
  * \file
  * \ingroup core-tests
  * \ingroup randomvariable
- * \ingroup randomvariable-tests
+ * \ingroup rng-tests
  * Test for one uniform random variable stream.
  */
 
@@ -39,15 +39,13 @@
 {
 
 /**
- * \ingroup randomvariable-tests
+ * \ingroup rng-tests
  * Test case for one uniform distribution random variable stream generator
  */
 class OneUniformRandomVariableManyGetValueCallsTestCase : public TestCase
 {
   public:
-    /** Constructor. */
     OneUniformRandomVariableManyGetValueCallsTestCase();
-    /** Destructor. */
     ~OneUniformRandomVariableManyGetValueCallsTestCase() override;
 
   private:
@@ -89,25 +87,24 @@
 }
 
 /**
- * \ingroup randomvariable-tests
+ * \ingroup rng-tests
  * Test suite for one uniform distribution random variable stream generator
  */
 class OneUniformRandomVariableManyGetValueCallsTestSuite : public TestSuite
 {
   public:
-    /** Constructor. */
     OneUniformRandomVariableManyGetValueCallsTestSuite();
 };
 
 OneUniformRandomVariableManyGetValueCallsTestSuite::
     OneUniformRandomVariableManyGetValueCallsTestSuite()
-    : TestSuite("one-uniform-random-variable-many-get-value-calls", PERFORMANCE)
+    : TestSuite("one-uniform-random-variable-many-get-value-calls", Type::PERFORMANCE)
 {
     AddTestCase(new OneUniformRandomVariableManyGetValueCallsTestCase);
 }
 
 /**
- * \ingroup randomvariable-tests
+ * \ingroup rng-tests
  * OneUniformRandomVariableManyGetValueCallsTestSuite instance variable.
  */
 static OneUniformRandomVariableManyGetValueCallsTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/pair-value-test-suite.cc ns-3.42/src/core/test/pair-value-test-suite.cc
--- ns-3.41/src/core/test/pair-value-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/pair-value-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -211,10 +211,10 @@
 };
 
 PairValueTestSuite::PairValueTestSuite()
-    : TestSuite("pair-value-test-suite", UNIT)
+    : TestSuite("pair-value-test-suite", Type::UNIT)
 {
-    AddTestCase(new PairValueTestCase(), TestCase::QUICK);
-    AddTestCase(new PairValueSettingsTestCase(), TestCase::QUICK);
+    AddTestCase(new PairValueTestCase(), TestCase::Duration::QUICK);
+    AddTestCase(new PairValueSettingsTestCase(), TestCase::Duration::QUICK);
 }
 
 static PairValueTestSuite g_pairValueTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/random-variable-stream-test-suite.cc ns-3.42/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.41/src/core/test/random-variable-stream-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/random-variable-stream-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -26,6 +26,7 @@
 #include "ns3/log.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/rng-seed-manager.h"
+#include "ns3/shuffle.h"
 #include "ns3/string.h"
 #include "ns3/test.h"
 
@@ -2873,6 +2874,71 @@
 }
 
 /**
+ * \ingroup rng-test
+ * \ingroup tests
+ *
+ * \brief Test the Shuffle function
+ *
+ * Check that the Shuffle function actually shuffles the elements and does so in a portable way.
+ */
+class ShuffleElementsTest : public TestCase
+{
+  public:
+    ShuffleElementsTest();
+
+  private:
+    void DoRun() override;
+};
+
+ShuffleElementsTest::ShuffleElementsTest()
+    : TestCase("Check correct operation of the Shuffle function")
+{
+}
+
+void
+ShuffleElementsTest::DoRun()
+{
+    RngSeedManager::SetSeed(1);
+    RngSeedManager::SetRun(1);
+
+    auto rv = CreateObject<UniformRandomVariable>();
+    rv->SetStream(1);
+
+    // test empty vector
+    std::vector<uint8_t> vec{};
+
+    Shuffle(vec.begin(), vec.end(), rv);
+
+    NS_TEST_EXPECT_MSG_EQ(vec.empty(), true, "Expected an empty vector");
+
+    // test vector with one value
+    vec.push_back(3);
+
+    Shuffle(vec.begin(), vec.end(), rv);
+
+    NS_TEST_EXPECT_MSG_EQ((vec == std::vector<uint8_t>{3}), true, "Expected vector {3}");
+
+    // test vector with two values
+    vec.push_back(1);
+
+    Shuffle(vec.begin(), vec.end(), rv);
+
+    NS_TEST_EXPECT_MSG_EQ((vec == std::vector<uint8_t>{1, 3}), true, "Expected vector {1, 3}");
+
+    // test vector with multiple values
+    vec.push_back(7);
+    vec.push_back(2);
+    vec.push_back(4);
+    vec.push_back(9);
+
+    Shuffle(vec.begin(), vec.end(), rv);
+
+    NS_TEST_EXPECT_MSG_EQ((vec == std::vector<uint8_t>{4, 1, 9, 3, 2, 7}),
+                          true,
+                          "Expected vector {4, 1, 9, 3, 2, 7}");
+}
+
+/**
  * \ingroup rng-tests
  * RandomVariableStream test suite, covering all random number variable
  * stream generator types.
@@ -2885,7 +2951,7 @@
 };
 
 RandomVariableSuite::RandomVariableSuite()
-    : TestSuite("random-variable-stream-generators", UNIT)
+    : TestSuite("random-variable-stream-generators", Type::UNIT)
 {
     AddTestCase(new UniformTestCase);
     AddTestCase(new UniformAntitheticTestCase);
@@ -2928,6 +2994,7 @@
     AddTestCase(new BernoulliAntitheticTestCase);
     AddTestCase(new BinomialTestCase);
     AddTestCase(new BinomialAntitheticTestCase);
+    AddTestCase(new ShuffleElementsTest);
 }
 
 static RandomVariableSuite randomVariableSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/rng-test-suite.cc ns-3.42/src/core/test/rng-test-suite.cc
--- ns-3.41/src/core/test/rng-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/rng-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -488,12 +488,12 @@
 };
 
 RngTestSuite::RngTestSuite()
-    : TestSuite("random-number-generators", UNIT)
+    : TestSuite("random-number-generators", Type::UNIT)
 {
-    AddTestCase(new RngUniformTestCase, TestCase::QUICK);
-    AddTestCase(new RngNormalTestCase, TestCase::QUICK);
-    AddTestCase(new RngExponentialTestCase, TestCase::QUICK);
-    AddTestCase(new RngParetoTestCase, TestCase::QUICK);
+    AddTestCase(new RngUniformTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new RngNormalTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new RngExponentialTestCase, TestCase::Duration::QUICK);
+    AddTestCase(new RngParetoTestCase, TestCase::Duration::QUICK);
 }
 
 static RngTestSuite g_rngTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/simulator-test-suite.cc ns-3.42/src/core/test/simulator-test-suite.cc
--- ns-3.41/src/core/test/simulator-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/simulator-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -721,15 +721,15 @@
         ObjectFactory factory;
         factory.SetTypeId(ListScheduler::GetTypeId());
 
-        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::QUICK);
+        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::Duration::QUICK);
         factory.SetTypeId(MapScheduler::GetTypeId());
-        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::QUICK);
+        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::Duration::QUICK);
         factory.SetTypeId(HeapScheduler::GetTypeId());
-        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::QUICK);
+        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::Duration::QUICK);
         factory.SetTypeId(CalendarScheduler::GetTypeId());
-        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::QUICK);
+        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::Duration::QUICK);
         factory.SetTypeId(PriorityQueueScheduler::GetTypeId());
-        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::QUICK);
+        AddTestCase(new SimulatorEventsTestCase(factory), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/threaded-test-suite.cc ns-3.42/src/core/test/threaded-test-suite.cc
--- ns-3.41/src/core/test/threaded-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/threaded-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -311,7 +311,7 @@
                     factory.SetTypeId(schedulerType);
                     AddTestCase(
                         new ThreadedSimulatorEventsTestCase(factory, simulatorType, threadCount),
-                        TestCase::QUICK);
+                        TestCase::Duration::QUICK);
                 }
             }
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/timer-test-suite.cc ns-3.42/src/core/test/timer-test-suite.cc
--- ns-3.41/src/core/test/timer-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/timer-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -229,10 +229,10 @@
 {
   public:
     TimerTestSuite()
-        : TestSuite("timer", UNIT)
+        : TestSuite("timer", Type::UNIT)
     {
-        AddTestCase(new TimerStateTestCase(), TestCase::QUICK);
-        AddTestCase(new TimerTemplateTestCase(), TestCase::QUICK);
+        AddTestCase(new TimerStateTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new TimerTemplateTestCase(), TestCase::Duration::QUICK);
     }
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/time-test-suite.cc ns-3.42/src/core/test/time-test-suite.cc
--- ns-3.41/src/core/test/time-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/time-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -542,12 +542,12 @@
 {
   public:
     TimeTestSuite()
-        : TestSuite("time", UNIT)
+        : TestSuite("time", Type::UNIT)
     {
-        AddTestCase(new TimeWithSignTestCase(), TestCase::QUICK);
-        AddTestCase(new TimeInputOutputTestCase(), TestCase::QUICK);
+        AddTestCase(new TimeWithSignTestCase(), TestCase::Duration::QUICK);
+        AddTestCase(new TimeInputOutputTestCase(), TestCase::Duration::QUICK);
         // This should be last, since it changes the resolution
-        AddTestCase(new TimeSimpleTestCase(), TestCase::QUICK);
+        AddTestCase(new TimeSimpleTestCase(), TestCase::Duration::QUICK);
     }
 }
 /** \brief Member variable for time test suite */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/traced-callback-test-suite.cc ns-3.42/src/core/test/traced-callback-test-suite.cc
--- ns-3.41/src/core/test/traced-callback-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/traced-callback-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -145,9 +145,9 @@
 };
 
 TracedCallbackTestSuite::TracedCallbackTestSuite()
-    : TestSuite("traced-callback", UNIT)
+    : TestSuite("traced-callback", Type::UNIT)
 {
-    AddTestCase(new BasicTracedCallbackTestCase, TestCase::QUICK);
+    AddTestCase(new BasicTracedCallbackTestCase, TestCase::Duration::QUICK);
 }
 
 static TracedCallbackTestSuite
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/trickle-timer-test-suite.cc ns-3.42/src/core/test/trickle-timer-test-suite.cc
--- ns-3.41/src/core/test/trickle-timer-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/trickle-timer-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -142,6 +142,8 @@
                              expirationFrequency.begin());
     expirationFrequency.erase(expirationFrequency.begin());
 
+    NS_TEST_ASSERT_MSG_EQ(expirationFrequency.empty(), false, "No expiration frequency");
+
     int64x64_t min =
         (*std::min_element(expirationFrequency.begin(), expirationFrequency.end())) / unit;
     int64x64_t max =
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/tuple-value-test-suite.cc ns-3.42/src/core/test/tuple-value-test-suite.cc
--- ns-3.41/src/core/test/tuple-value-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/tuple-value-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -321,9 +321,9 @@
 };
 
 TupleValueTestSuite::TupleValueTestSuite()
-    : TestSuite("tuple-value-test-suite", UNIT)
+    : TestSuite("tuple-value-test-suite", Type::UNIT)
 {
-    AddTestCase(new TupleValueTestCase(), TestCase::QUICK);
+    AddTestCase(new TupleValueTestCase(), TestCase::Duration::QUICK);
 }
 
 static TupleValueTestSuite g_tupleValueTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/core/test/type-id-test-suite.cc ns-3.42/src/core/test/type-id-test-suite.cc
--- ns-3.41/src/core/test/type-id-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
+++ ns-3.42/src/core/test/type-id-test-suite.cc	2024-05-29 15:29:46.940073000 -0700
@@ -443,7 +443,7 @@
 };
 
 TypeIdTestSuite::TypeIdTestSuite()
-    : TestSuite("type-id", UNIT)
+    : TestSuite("type-id", Type::UNIT)
 {
     // Turn on logging, so we see the result of collisions
     LogComponentEnable("TypeId", ns3::LogLevel(LOG_ERROR | LOG_PREFIX_FUNC));
@@ -452,9 +452,9 @@
     // UniqueIdTestCase, the artificial collisions added by
     // CollisionTestCase will show up in the list of TypeIds
     // as chained.
-    AddTestCase(new UniqueTypeIdTestCase, QUICK);
-    AddTestCase(new CollisionTestCase, QUICK);
-    AddTestCase(new DeprecatedAttributeTestCase, QUICK);
+    AddTestCase(new UniqueTypeIdTestCase, Duration::QUICK);
+    AddTestCase(new CollisionTestCase, Duration::QUICK);
+    AddTestCase(new DeprecatedAttributeTestCase, Duration::QUICK);
 }
 
 /// Static variable for test initialization.
@@ -472,9 +472,9 @@
 };
 
 TypeIdPerformanceSuite::TypeIdPerformanceSuite()
-    : TestSuite("type-id-perf", PERFORMANCE)
+    : TestSuite("type-id-perf", Type::PERFORMANCE)
 {
-    AddTestCase(new LookupTimeTestCase, QUICK);
+    AddTestCase(new LookupTimeTestCase, Duration::QUICK);
 }
 
 /// Static variable for test initialization.
